#!/usr/bin/perl
# Ordnet den phonemen ein visem zu und gibt dieses ber die Standardausgabe aus
# Aufruf: mlf2vis mapfile <in >out
# Aufbau des Mapfiles: Zeilenweise immer:
# phonem visem
# Viseme drfen mehrfach angegeben werden
# Die Benennung der Mapdateien ist immer das Format, aus dem in sapi reingemappt wird.

use strict;
use warnings;
use locale;

my $debug=0;
my %map;

open (MAP, "$ARGV[0]") or die "Can't open mapfile \"$ARGV[0]\"! $!\n";

$debug==1 and print "Substitutionen\n";
while (<MAP>) {
	chomp;
	next if (/^#/);
	my ($phonem, $visem) = split(/\t/);
	$map{$phonem}=$visem;
	#in $map{$phonem} steht das Mapping
	$debug==1 and print "$phonem -> $visem\n";
}
close MAP;

while (<STDIN>){
	chomp;
	my @inputline = split;
	next if $#inputline < 2;
	if (! defined $map{$inputline[2]} ) {
		print STDERR "Phone $inputline[2] is unknown!\n";
		$map{$inputline[2]}="unknown!";
	}
	print "$inputline[0] $inputline[1] $map{$inputline[2]}\n";
}
