#!/usr/bin/perl
# vis2frm - gibt an, welches Visem bei welchem Frame steht Eingabe ber
# stdin, ausgabe ber stdout.
# $1 : Framelnge in Vielfachem von 1 s, bei 25 Frm/s sind das also 1/25
# $s=0.04s = 40000

use strict;
use warnings;
use locale;

my $frameno=0;
my $framelength=$ARGV[0] or die "\$1 missing (frame length)"; #Konvertierung ins HTK-Format
$framelength = $framelength * 10;
my $pos=0;


while (<STDIN>)
{ 
	chomp;
	my ($sta, $end, @vis) = split (/ /, $_); 
#	print "$sta, $end, $pos\n";
	while (($sta <= $pos) & ($pos < $end))     
# $pos <= $end, falls dieselbe Position in den Alignten dateien NICHT
# vorkme (was sie aber leider tut)
	{
                print "@vis\n";
                $pos=$pos + $framelength;
                $frameno = $frameno + 1;
        }

}
